/*
 * The Helper executable to integrate P4 commands into MS Explorer
 * Copyright (c) 2001 Rajesh Vaidheeswarran
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * $Id: p4cmd.c,v 1.3 2001/11/09 20:06:24 rv Exp $
 */
#include <stdio.h>
#include <string.h>
#include <unistd.h>

static void
usage()
{
    fprintf(stderr,
	    "This program shouldn't be executed directly.\n"
	    "This is a backend program for P4 integration with\n"
	    "the Windows Explorer menu.\n"
	    "\n"
	    "P4-Explorer integration v" VERSION "\n"
	    "Copyright (c) 2001 Rajesh Vaidheeswarran\n"
	    "\n"
	    "This program is free software; you can redistribute it and/or modify\n"
	    "it under the terms of the GNU General Public License as published by\n"
	    "the Free Software Foundation; either version 2 of the License, or\n"
	    "(at your option) any later version.\n"
	    "\n"
	    "This program is distributed in the hope that it will be useful,\n"
	    "but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
	    "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n"
	    "GNU General Public License for more details.\n"
	    "\n"
	    "You should have received a copy of the GNU General Public License\n"
	    "along with this program; see the file COPYING.  If not, write to\n"
	    "the Free Software Foundation, Inc., 59 Temple Place - Suite 330,\n"
	    "Boston, MA 02111-1307, USA.\n");
}

static int
confirmed(char *cmd, char *fn)
{
    if (strcmp(cmd, "delete") == 0 ||
	strcmp(cmd, "revert") == 0) {
	char conf[10];
	strcpy(conf, "no!");
	printf("Are you sure you want to %s %s? (no/yes): ", cmd, fn);
	scanf("%3s", conf);
	return strncasecmp("yes", conf, 3) == 0;
    }
    return 1;
}

int
main(int ac, char **av)
{
    char *p4cmd = 0, *fn = 0, *op, *np;
    char dir[1024]; // ridiculous max len
    char cmd[2048];
    if (ac < 3) {
	usage();
	return -1;
    }
    p4cmd = av[1];
    fn = av[2];
    op = np = fn;
    //printf("file = %s\n", fn);
    do {
	op = np;
    } while ((np = strstr(op+1, "\\")) != 0);

    // here the op+1 should be the file name..
    // and  fn - op should be the directory.
    // printf("op = %s, np = %s\n", op, np);
    snprintf(dir, op-fn+1, "%s", fn);
    if (confirmed(p4cmd, fn)) {
	sprintf(cmd, P4INSTALL "/p4cmd.bat %s \"%s\" \"%s\"",
		p4cmd, dir, fn);
	system(cmd);
    }
    return 0;
}
